import { Lexer } from "chevrotain";
import { BaseParser } from "./parser";
import { AbstractTree, CronExpression, Expression } from "./syntax/base";
import { QuartzCronExpression } from "./syntax/quartz";
export interface CronExpr {
    second?: string;
    minute?: string;
    hour?: string;
    dayOfMonth?: string;
    month?: string;
    dayOfWeek?: string;
    year?: string;
}
export declare enum CronMode {
    CRONTAB = "Crontab",
    QUARTZ = "Quartz",
    JENKINS = "Jenkins"
}
interface CronOptions {
    mode: CronMode;
    loose?: boolean;
}
export declare class ExprElement {
    private readonly _ast;
    constructor(expr: AbstractTree | string);
    readonly ast: AbstractTree;
    readonly value: string;
}
export declare function getParser(context: CronOptions): BaseParser;
export declare function getLexer(context: CronOptions): Lexer;
export declare function cron(expression: string | CronExpr, options?: CronOptions): CronExpression | QuartzCronExpression;
export declare function interval(lhs: string | AbstractTree, rhs: string | AbstractTree): import("./syntax/base").DualExpression;
export declare function range(lhs: string | AbstractTree, rhs: string | AbstractTree): import("./syntax/base").DualExpression;
export declare function union(...values: (string | AbstractTree)[]): Expression;
export {};
