import { ICstVisitor } from "chevrotain";
import { AbstractTree, CronExpression, Expression, StringLiteral } from "../syntax/base";
import { AtomicExprContext, CronContext, CronExpressionContext, ExpressionContext, ExprNotUnionContext, OperationContext } from "./context";
declare const abstractVisitor: <T extends new (...args: any[]) => ICstVisitor<any, any>>(base: T) => {
    new (...args: any[]): {
        cron(ctx: CronContext): any;
        cronExpression(ctx: CronExpressionContext): CronExpression;
        expression(ctx: ExpressionContext): Expression;
        exprNotUnion(ctx: ExprNotUnionContext): any;
        atomicExpr(ctx: AtomicExprContext, lhs: StringLiteral): AbstractTree;
        interval(ctx: OperationContext): StringLiteral;
        range(ctx: OperationContext): StringLiteral;
        visit(cstNode: import("chevrotain").CstNode | import("chevrotain").CstNode[], param?: any): any;
        validateVisitor(): void;
    };
} & T;
export default abstractVisitor;
