import { StringLiteral } from "../syntax/base";
import { DayOfWeekExpr, QuartzCronExpression } from "../syntax/quartz";
import { DowContext, QuartzCronExpressionContext, QuartzExprNotUnionContext } from "./context/quartz";
declare const QuartzVisitorConstructor: {
    new (...args: any[]): {
        cron(ctx: import("./context").CronContext): any;
        cronExpression(ctx: import("./context").CronExpressionContext): import("../syntax/base").CronExpression;
        expression(ctx: import("./context").ExpressionContext): import("../syntax/base").Expression;
        exprNotUnion(ctx: import("./context").ExprNotUnionContext): any;
        atomicExpr(ctx: import("./context").AtomicExprContext, lhs: StringLiteral): import("../syntax/base").AbstractTree;
        interval(ctx: import("./context").OperationContext): StringLiteral;
        range(ctx: import("./context").OperationContext): StringLiteral;
        visit(cstNode: import("chevrotain").CstNode | import("chevrotain").CstNode[], param?: any): any;
        validateVisitor(): void;
    };
} & (new (...args: any[]) => import("chevrotain").ICstVisitor<any, any>);
export default class QuartzVisitor extends QuartzVisitorConstructor {
    constructor();
    cronExpression(ctx: QuartzCronExpressionContext): QuartzCronExpression;
    exprNotUnion(ctx: QuartzExprNotUnionContext): any;
    dow(ctx: DowContext, lhs: StringLiteral): DayOfWeekExpr;
}
export {};
