"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var chevrotain=require("chevrotain"),tslib=require("tslib");function genVocabulary(e){return e.reduce((function(e,r){return e[r.name]=r,e}),{})}var whiteSpace=chevrotain.createToken({name:"whiteSpace",pattern:/\s+/,group:chevrotain.Lexer.SKIPPED}),identifier=chevrotain.createToken({name:"identifier",pattern:chevrotain.Lexer.NA}),months=chevrotain.createToken({name:"months",pattern:/JAN|FEB|MAR|APR|MAY|JUN|JUL|AUG|SEP|OCT|NOV|DEC/,categories:[identifier]}),days=chevrotain.createToken({name:"days",pattern:/SUN|MON|TUE|WED|THU|FRI|SAT/,categories:[identifier]}),dash=chevrotain.createToken({name:"dash",pattern:/-/}),slash=chevrotain.createToken({name:"slash",pattern:/\//}),comma=chevrotain.createToken({name:"comma",pattern:/,/}),integer=chevrotain.createToken({name:"integer",pattern:/[0-9]{1,2}/,categories:[identifier]}),every=chevrotain.createToken({name:"every",pattern:/\*/,categories:[identifier]}),cronTokens=[whiteSpace,identifier,months,days,dash,slash,comma,integer,every],cronVocabulary=genVocabulary(cronTokens),anyToken=chevrotain.createToken({name:"anyToken",pattern:/\?/,categories:[identifier]}),sharp=chevrotain.createToken({name:"sharp",pattern:/#/}),last=chevrotain.createToken({name:"last",pattern:/L/,categories:[identifier]}),weekday=chevrotain.createToken({name:"weekday",pattern:/W/,categories:[identifier]}),quartzTokens=tslib.__spreadArrays(cronTokens,[anyToken,sharp,last,weekday]),quartzVocabulary=genVocabulary(quartzTokens),roundTime=chevrotain.createToken({name:"roundTime",pattern:/H/,categories:[identifier]}),jenkinsTokens=tslib.__spreadArrays([roundTime],cronTokens),jenkinsVocabulary=genVocabulary(jenkinsTokens),BaseParser=function(e){function r(r,t){void 0===t&&(t=!1);var n=e.call(this,r)||this;return n.cron=n.RULE("cron",(function(){return n.SUBRULE(n.cronExpression)})),n.cronExpression=n.RULE("cronExpression",(function(){n.SUBRULE1(n.expression,{LABEL:"minutes"}),n.SUBRULE2(n.expression,{LABEL:"hours"}),n.SUBRULE3(n.expression,{LABEL:"dom"}),n.SUBRULE4(n.expression,{LABEL:"month"}),n.SUBRULE5(n.expression,{LABEL:"dow"})})),n.expression=n.RULE("expression",(function(){n.AT_LEAST_ONE_SEP({SEP:comma,DEF:function(){return n.SUBRULE(n.exprNotUnion)}})})),n.exprNotUnion=n.RULE("exprNotUnion",(function(){n.CONSUME(identifier,{LABEL:"lhs"}),n.SUBRULE(n.atomicExpr)})),n.atomicExpr=n.RULE("atomicExpr",(function(){n.OPTION1({DEF:function(){return n.SUBRULE1(n.range)}}),n.OPTION2({DEF:function(){return n.SUBRULE2(n.interval)}})})),n.interval=n.RULE("interval",(function(){n.CONSUME1(slash),n.CONSUME2(identifier,{LABEL:"rhs"})})),n.range=n.RULE("range",(function(){n.CONSUME1(dash),n.CONSUME2(identifier,{LABEL:"rhs"})})),t||n.performSelfAnalysis(),n}return tslib.__extends(r,e),r}(chevrotain.CstParser),JenkinsParser=function(e){function r(){var r=e.call(this,jenkinsVocabulary,!0)||this;return r.performSelfAnalysis(),r}return tslib.__extends(r,e),r}(BaseParser),QuartzParser=function(e){function r(){var r=e.call(this,quartzVocabulary,!0)||this;return r.cronExpression=r.OVERRIDE_RULE("cronExpression",(function(){r.SUBRULE1(r.expression,{LABEL:"second"}),r.SUBRULE2(r.expression,{LABEL:"minutes"}),r.SUBRULE3(r.expression,{LABEL:"hours"}),r.SUBRULE4(r.expression,{LABEL:"dom"}),r.SUBRULE5(r.expression,{LABEL:"month"}),r.SUBRULE6(r.expression,{LABEL:"dow"}),r.OPTION({DEF:function(){return r.SUBRULE7(r.expression,{LABEL:"year"})}})})),r.exprNotUnion=r.OVERRIDE_RULE("exprNotUnion",(function(){r.CONSUME(identifier,{LABEL:"lhs"}),r.OPTION({DEF:function(){return r.OR([{ALT:function(){return r.SUBRULE(r.dow)}},{ALT:function(){return r.SUBRULE(r.atomicExpr)}}])}})})),r.dow=r.RULE("dow",(function(){r.OR([{ALT:function(){return r.CONSUME(last,{LABEL:"occurence"})}},{ALT:function(){r.CONSUME1(sharp),r.CONSUME2(integer,{LABEL:"occurence"})}}])})),r.performSelfAnalysis(),r}return tslib.__extends(r,e),r}(BaseParser),default_1=function(){},default_1$1=function(e){function r(r,t,n){var o=e.call(this)||this;return o._rhs=t,o._lhs=r,o._separator=n,o}return tslib.__extends(r,e),r.prototype.value=function(){return""+this._lhs.value()+this._separator+this._rhs.value()},r}(default_1),default_1$2=function(e){function r(r){var t=e.call(this)||this;return t._value=r,t}return tslib.__extends(r,e),r.prototype.value=function(){return this._value},r}(default_1),Cron=function(e){function r(){return null!==e&&e.apply(this,arguments)||this}return tslib.__extends(r,e),r.prototype.value=function(){return this.cronExpression.value()},r}(default_1),CronExpression=function(e){function r(r,t,n,o,i){void 0===r&&(r=everyExpr),void 0===t&&(t=everyExpr),void 0===n&&(n=everyExpr),void 0===o&&(o=everyExpr),void 0===i&&(i=everyExpr);var s=e.call(this)||this;return s._dow=i,s._minute=r,s._hour=t,s._dom=n,s._month=o,s}return tslib.__extends(r,e),Object.defineProperty(r.prototype,"minute",{get:function(){return this._minute},set:function(e){this._minute=e},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"hour",{get:function(){return this._hour},set:function(e){this._hour=e},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"dom",{get:function(){return this._dom},set:function(e){this._dom=e},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"month",{get:function(){return this._month},set:function(e){this._month=e},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"dow",{get:function(){return this._dow},set:function(e){this._dow=e},enumerable:!0,configurable:!0}),r.prototype.value=function(){return" "+this._minute.value()+" "+this._hour.value()+" "+this._dom.value()+" "+this._month.value()+" "+this._dow.value()},r}(default_1),default_1$3=function(e){function r(r){var t=e.call(this)||this;return t._exprs=r,t}return tslib.__extends(r,e),r.prototype.value=function(){return this._exprs.map((function(e){return e.value()})).join(",")},r}(default_1);function intervalExpr(e,r){return new default_1$1(e,r,"/")}function rangeExpr(e,r){return new default_1$1(e,r,"-")}var everyExpr=new default_1$2("*"),anyExpr=new default_1$2("?"),abstractVisitor=function(e){return function(e){function r(){for(var r=[],t=0;t<arguments.length;t++)r[t]=arguments[t];var n=e.call(this,r)||this;return n.validateVisitor(),n}return tslib.__extends(r,e),r.prototype.cron=function(e){return this.visit(e.cronExpression)},r.prototype.cronExpression=function(e){var r=new CronExpression;return r.minute=this.visit(e.minutes),r.hour=this.visit(e.hours),r.dom=this.visit(e.dom),r.month=this.visit(e.month),r.dow=this.visit(e.dow),r},r.prototype.expression=function(e){var r=this,t=e.exprNotUnion.map((function(e){return r.visit(e)}));return new default_1$3(t)},r.prototype.exprNotUnion=function(e){var r=new default_1$2(e.lhs[0].image);return this.visit(e.atomicExpr,r)},r.prototype.atomicExpr=function(e,r){var t=r;if(e.range){var n=this.visit(e.range),o=Number(r.value()),i=Number(n.value());if(NaN!==o&&NaN!==i&&o>i)throw new Error("Left-hand side range value must be smaller than right-hand side");t=rangeExpr(r,n)}return e.interval&&(t=intervalExpr(t,this.visit(e.interval))),t},r.prototype.interval=function(e){return new default_1$2(e.rhs[0].image)},r.prototype.range=function(e){return new default_1$2(e.rhs[0].image)},r}(e)},BaseVisitorConstructor=abstractVisitor(new BaseParser(cronVocabulary).getBaseCstVisitorConstructor()),BaseVisitor=function(e){function r(){return e.call(this,BaseVisitorConstructor)||this}return tslib.__extends(r,e),r}(BaseVisitorConstructor),JenkinsVisitorConstructor=abstractVisitor((new JenkinsParser).getBaseCstVisitorConstructor()),JenkinsVisitor=function(e){function r(){return e.call(this,JenkinsVisitorConstructor)||this}return tslib.__extends(r,e),r}(JenkinsVisitorConstructor),default_1$4=function(e){function r(r,t,n,o,i,s,a){void 0===r&&(r=everyExpr),void 0===t&&(t=everyExpr),void 0===n&&(n=everyExpr),void 0===o&&(o=everyExpr),void 0===i&&(i=anyExpr),void 0===s&&(s=everyExpr),void 0===a&&(a=everyExpr);var u=e.call(this,r,t,n,o,i)||this;return u._second=s,u._year=a,u}return tslib.__extends(r,e),Object.defineProperty(r.prototype,"second",{get:function(){return this._second},set:function(e){this._second=e},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"year",{get:function(){return this._year},set:function(e){this._year=e},enumerable:!0,configurable:!0}),r.prototype.value=function(){return this.second.value()+" "+e.prototype.value.call(this)+" "+this.year.value()},r}(CronExpression),default_1$5=function(e){function r(r,t){var n=e.call(this)||this;return n._leftValue=r,n._occurence=t,n}return tslib.__extends(r,e),Object.defineProperty(r.prototype,"occurence",{get:function(){return this._occurence},set:function(e){this._occurence=e},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"leftValue",{get:function(){return this._leftValue},set:function(e){this._leftValue=e},enumerable:!0,configurable:!0}),r.prototype.value=function(){var e=this._occurence<5?"#"+this._occurence:"L";return""+this._leftValue.value()+e},r}(default_1),QuartzVisitorConstructor=abstractVisitor((new QuartzParser).getBaseCstVisitorConstructor()),QuartzVisitor=function(e){function r(){return e.call(this,QuartzVisitorConstructor)||this}return tslib.__extends(r,e),r.prototype.cronExpression=function(e){var r=new default_1$4;return e.second&&(r.second=this.visit(e.second)),r.minute=this.visit(e.minutes),r.hour=this.visit(e.hours),r.dom=this.visit(e.dom),r.month=this.visit(e.month),r.dow=this.visit(e.dow),e.year&&(r.year=this.visit(e.year)),r},r.prototype.exprNotUnion=function(e){var r=new default_1$2(e.lhs[0].image);return e.dow?this.visit(e.dow,r):this.visit(e.atomicExpr,r)},r.prototype.dow=function(e,r){var t="L"===e.occurence[0].image?5:parseInt(e.occurence[0].image,10);return new default_1$5(r,t)},r}(QuartzVisitorConstructor);function isString(e){return"string"==typeof e}!function(e){e.CRONTAB="Crontab",e.QUARTZ="Quartz",e.JENKINS="Jenkins"}(exports.CronMode||(exports.CronMode={}));var ExprElement=function(){function e(e){isString(e)?this._ast=new default_1$2(e):this._ast=e}return Object.defineProperty(e.prototype,"ast",{get:function(){return this._ast},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"value",{get:function(){return this._ast.value()},enumerable:!0,configurable:!0}),e}();function isCronException(e){return void 0!==e.hour}function getParser(e){switch(e.mode){case exports.CronMode.QUARTZ:return new QuartzParser;case exports.CronMode.JENKINS:return new JenkinsParser;default:return new BaseParser(cronVocabulary)}}function getLexer(e){var r=[];switch(e.mode){case exports.CronMode.QUARTZ:r=quartzTokens;break;case exports.CronMode.JENKINS:r=jenkinsTokens;break;default:r=cronTokens}return new chevrotain.Lexer(r)}function computeExpr(e,r){var t,n;switch(r.mode){case exports.CronMode.QUARTZ:return n=new chevrotain.Lexer(quartzTokens).tokenize(e),(t=new QuartzParser).input=n.tokens,(new QuartzVisitor).visit(t.cron());case exports.CronMode.JENKINS:return n=new chevrotain.Lexer(jenkinsTokens).tokenize(e),(t=new JenkinsParser).input=n.tokens,(new JenkinsVisitor).visit(t.cron());case exports.CronMode.CRONTAB:default:return n=new chevrotain.Lexer(cronTokens).tokenize(e),(t=new BaseParser(cronVocabulary)).input=n.tokens,(new BaseVisitor).visit(t.cron())}}function compute(e,r){var t=r.mode,n=[e.minute||"*",e.hour||"*",e.dayOfMonth||"*",e.month||"*",e.dayOfWeek||"*"];switch(t){case exports.CronMode.QUARTZ:var o=n;return e.second&&(o=[e.second].concat(n)),e.year&&o.push(e.year),o.join(" ");case exports.CronMode.JENKINS:case exports.CronMode.CRONTAB:default:return n.join(" ")}}function cron(e,r){return void 0===r&&(r={mode:exports.CronMode.CRONTAB,loose:!1}),computeExpr(isCronException(e)?compute(e,r):e,r)}function interval(e,r){return intervalExpr(isString(e)?new default_1$2(e):e,isString(r)?new default_1$2(r):r)}function range(e,r){return rangeExpr(isString(e)?new default_1$2(e):e,isString(r)?new default_1$2(r):r)}function union(){for(var e=[],r=0;r<arguments.length;r++)e[r]=arguments[r];var t=e.map((function(e){return isString(e)?new default_1$2(e):e}));return new default_1$3(t)}exports.AbstractTree=default_1,exports.AbstractVisitor=abstractVisitor,exports.BaseParser=BaseParser,exports.BaseVisitor=BaseVisitor,exports.Cron=Cron,exports.CronExpression=CronExpression,exports.DayOfWeekExpr=default_1$5,exports.DualExpression=default_1$1,exports.ExprElement=ExprElement,exports.Expression=default_1$3,exports.JenkinsParser=JenkinsParser,exports.JenkinsVisitor=JenkinsVisitor,exports.QuartzCronExpression=default_1$4,exports.QuartzParser=QuartzParser,exports.QuartzVisitor=QuartzVisitor,exports.StringLiteral=default_1$2,exports.anyExpr=anyExpr,exports.anyToken=anyToken,exports.comma=comma,exports.cron=cron,exports.cronTokens=cronTokens,exports.cronVocabulary=cronVocabulary,exports.dash=dash,exports.days=days,exports.every=every,exports.everyExpr=everyExpr,exports.genVocabulary=genVocabulary,exports.getLexer=getLexer,exports.getParser=getParser,exports.identifier=identifier,exports.integer=integer,exports.interval=interval,exports.intervalExpr=intervalExpr,exports.jenkinsTokens=jenkinsTokens,exports.jenkinsVocabulary=jenkinsVocabulary,exports.last=last,exports.months=months,exports.quartzTokens=quartzTokens,exports.quartzVocabulary=quartzVocabulary,exports.range=range,exports.rangeExpr=rangeExpr,exports.roundTime=roundTime,exports.sharp=sharp,exports.slash=slash,exports.union=union,exports.weekday=weekday,exports.whiteSpace=whiteSpace;
